_<p align="center">
	<img src="https://github.com/markmbain/aius/blob/main/assets/images/aius/aius-black.png" width="72px" alt="AIUS Logo">
</p>

<p align="center">
	<a href="https://opensource.org/licenses/MIT">
		<img src="https://img.shields.io/badge/License-MIT-green.svg" alt="License: MIT">
	</a>
    <a href="https://github.com/markmbain/aius">
        <img src="https://img.shields.io/github/last-commit/markmbain/aius.svg?style=flat&color=blue" alt="GitHub last commit"/>
    </a>
    <a href="https://github.com/markmbain/aius/releases">
        <img src="https://img.shields.io/github/release/markmbain/aius.svg?style=flat&color=success" alt="Version"/>
    </a>
<!-- 	<a href="https://pypi.python.org/pypi/aius">
		<img src="https://img.shields.io/pypi/v/aius.svg?style=flat-square&label=pypi+aius" alt="AIUS memory Python package on PyPi">
	</a> -->
	<a href="https://discord.gg/cM6vFhJbWS">
		<img src="https://img.shields.io/discord/1229216579208876242?style=social&logo=discord" alt="AIUS Discord">
	</a>
	<a href="https://x.com/markmbain">
		<img src="https://img.shields.io/twitter/follow/markmbain" alt="AIUS Twitter">
	</a>
</p>

---
# ● AIUS ●
⚡ The long-term memory system for your AI, powering ... ⚡ 

- 🥷 Superagents and 🤖 AI Agents
- 🗣️ AI assistants
- 🧠 LLMs 

> Built with GraphRAG, knowledge graphs, autonomous ai agents, latest research and a bit of magic ✨

---


# 🌟 Why AIUS - the big cause
We aim to __allow AI assistants and Superagents to remember and understand__:

- **You & Other Humans** - think: Empathetic AI assistants engaged in Conversational AI with you and other individuals they interact with.
	- ≠ Not just ≠ limited context-windows, system prompts, pre-trained/fine-tuned knowledge or RAG that doesn't work.
		- ✔️ **Learning you, from you and for you. Everything on-the-fly.**
			- 🤖 📚 💡 👨 👩
- **Themselves** - give them: self-consciousness. They'll know why they exist, their values, goals, preferences, memories of past interactions, tools and relationships.
	- ≠ Not just ≠ system prompts, prompt-engineered agent definitions with name, role, objectives, and function callings.
		- ✔️ **Having self-awareness that is: autonomous, dynamic, programmable, adaptable, controllable and safe.**
			- 🥷 🧠 🕰️ 🗣️ 🔒
- **Content** - envision: Specialized agents being able to remember and understand any content they are exposed to.
	- ≠ Not just ≠ static files from private data corpora in limited file formats
		- ✔️ **Processing multi-modal first-seen content in any format, streamed & static, in any language they know.**
			-  ➡️ 💬 🎵 🎬 📄 📡
- **Other agents and assistants** - imagine the AInet - an Internet of Agents, a new ecosystem of AI assistants, AI agents, humans and organizations of these.
	- ≠ Not just ≠ pre-trained, piped agents with Human-in-the-loop (HITL)
		- ✔️ **Building lasting relationships with other assistants, agents, humans and organizations**
			- 🌐 🗣️ 🤖 👥 💻 💼 

> It's a promise that keeps us going 👣 and shipping ⛴️ at a lightning speed ⚡️

---

# 💡 Key features & design patterns
- A configurable MemorySystem composed of a MemoryStorage layer, MemoryTypes, and MemoryPods.
- MemoryPods: configurable Pods that allow setting up separate storage units for different memory types, providing a security isolation layer.
- Custom MemoryStorages: think KV, Graph, Vector, and other DBMSes under the hood of MemoryPods.
- MemoryTypes: support for multiple memory types, i.e., episodic memory, entity memory, working memory (WM), short-term (STM), and long-term memory (LTM), etc.
- Simple high-level ontology:
    - Beings
        - Events (relating to energy)
        - Entities (relating to matter)
        - Relationships (relating to transformations)
- A composable system that allows:
    - Building beings—think agents, assistants, robots—and commissioning them with:
        - Input interfaces (Sensors)
        - A memory system
        - Processing functions
        - Output interfaces (Tools)

> We start small, ship, listen to feedback, break things, launch and go again.

---

# 🚀 Getting Started
```bash
# Install the repository
pip install aius
```

---

# 🔗 Join the community
- 🌐 (URL/Web): Visit: https://aius.co
- 💬 (Discord): Chat: https://discord.gg/cM6vFhJbWS
- ❌ (X/Twitter): Follow: https://x.com/markmbain
- 🔗 (LinkedIn): Follow: https://www.linkedin.com/company/aius-ai
- 🐙 (GitHub): Star & Fork: https://github.com/markmbain/aius
- 🐍 (PyPI): Install: https://pypi.org/project/aius/

---

# 🤝 Contribute
- ⭐️ Star the repo and become one of our [Stargazers](https://github.com/markmbain/aius/stargazers)
- 💬 [Join our discord](https://discord.gg/cM6vFhJbWS) to chat with the growing community about designs, contribution and use cases
- Clone: `git clone git@github.com:markmbain/aius.git` and play around
- 🍴 Fork, develop code, test, document, commit, create pull requests
- Create [New issues](https://github.com/markmbain/aius/issues/new)

```bash
# Clone the repo
git clone git@github.com:markmbain/aius.git
cd aius

# Install dependencies
pip install poetry
poetry install --with dev

```

---

# 📝 License
MIT License, Copyright (c) 2024 Mark Bain